Subject: [rddp] RE: AD review of draft-ietf-rddp-sctp-04

From: "Caitlin Bestler" <[email-masked]>
Date: Fri, 23 Jun 2006 12:43:22 -0700

Lars Eggert wrote:

> 
> 
> Section 6.1., paragraph 2:
> 
>  >    The Payload Data Chunks for a given session, when sequenced by
>  their >    DDP-SSN, MUST follow one of the patterns defined in
> this section.
> 
>    The sequence patterns in the remainder of this section don't
>    include any DDP-SSNs? How can compliance thus be established?   
> (See next comment.) 
> 
> 

All SCTP Data Chunks generated by the DDP/SCTP Adaptation have a
DDP-SSN.
Therefore all messages specified in this draft have DDP-SSNs.
 
> Section 6.2., paragraph 3:
> 
>  >       Passive Side sends a DDP Stream Session Accept message.
> 
>    Text above says this section describes a valid message exchange
>    based on DDP-SSNs. I'd thus have expected this section to talk
>    about DDP-SSNs, e.g., saying "active Side sends a DDP
> Stream Session
>    Initiate message with DDP-SSN zero", "passive Side sends a
> DDP Stream
>    Session Accept message with DDP-SSN zero" and so on. Am I
> making sense?
>    (Same for Sections 6.3, 6.4 and 6.5.)
>

The rules for formulating the DDP-SSN are already clear. The
fact that the messsages are sequenced clearly mandates what
the DDP-SSNs would be.

Since implementations are not likely to generate the DDP-SSNs
at the layer discussed in these sequence sections, I do not
see the value of repeating this information here.
 
> 
> Section 6.2., paragraph 4:
> 
>  >       Each side may then send zero or more DDP Segments with
>  increasing >       DDP-SSNs, subject to various layers of flow
> control. 
> 
>    What does "various layers of flow control" mean? What happens
>    when the DDP-SSN wraps? It's no longer increasing then.
>

will be changed to "subject to whatever flow control imposed by
other protocol layers".

As specified earlier, the DDP-SSN has the same semantics that
the SCTP SSN would have had if the stream had been SCTP ordered.
It is hard to imagine a wire protocol where a field labeled as
a "sequence number" did not have wraparound semantics, so I believe
the "Same as the SCTP SSN would have been" is sufficiently clear.

_______________________________________________
rddp mailing list
[email-masked]
https://www1.ietf.org/mailman/listinfo/rddp

---

From: Lars Eggert <[email-masked]>
Date: Mon, 26 Jun 2006 10:28:29 +0200

On Jun 23, 2006, at 21:43, Caitlin Bestler wrote:
>>> their DDP-SSN, MUST follow one of the patterns defined in this  
>>> section.
>>
> DDP-SSN. Therefore all messages specified in this draft have DDP-SSNs.

Right, but I was trying to raise a different question. Let me try again:

"The payload data chunks [...], when sequenced by their DDP-SSN, MUST  
follow one of the patterns defined in this section."

I read this sentence as: "This section will show sequences of packets  
together with their DDP-SSNs. Valid sessions MUST follow one of these  
DDP-SSN sequences.

Did I get the meaning correctly?

If yes, my comment was that the section doesn't actually talk about  
DDP-SSNs at all.

> fact that the messsages are sequenced clearly mandates what

Ah. So they are assumed to be implicitly clear. I think this is  
problematic, because in the beginning of this section, the drafts  
says that valid exchanges MUST follow on of the DDP-SSN sequences,  
but then doesn't explicitly define them. Explicitly defining the  
valid packet exchanges together with the DDP-SSNs in these sections  
allows implementors to easily verify whether they are in compliance.

> see the value of repeating this information here.

Hm. Maybe I simply got hung up on the phrasing here ("when sequenced  
by their DDP-SSN")?

Lars
-- 
Lars Eggert                                     NEC Network Laboratories